Type
object

Specification

PropertyTypeDescription
specobject

Configuration affecting load balancing, outlier detection, etc. See more details at: https://istio.io/docs/reference/config/networking/destination-rule.html

statusobject

.spec

Description
Configuration affecting load balancing, outlier detection, etc. See more details at: https://istio.io/docs/reference/config/networking/destination-rule.html
Type
object
PropertyTypeDescription
exportToarray

A list of namespaces to which this destination rule is exported.

hoststring

The name of a service from the service registry.

subsetsarray
trafficPolicyobject
workloadSelectorobject

.spec.exportTo

Description
A list of namespaces to which this destination rule is exported.
Type
array

.spec.exportTo[]

Type
string

.spec.subsets

Type
array

.spec.subsets[]

Type
object
PropertyTypeDescription
labelsobject
namestring

Name of the subset.

trafficPolicyobject

Traffic policies that apply to this subset.

.spec.subsets[].labels

Type
object

.spec.subsets[].trafficPolicy

Description
Traffic policies that apply to this subset.
Type
object
PropertyTypeDescription
connectionPoolobject
loadBalancerobject

Settings controlling the load balancer algorithms.

outlierDetectionobject
portLevelSettingsarray

Traffic policies specific to individual ports.

tlsobject

TLS related settings for connections to the upstream service.

tunnelobject

.spec.subsets[].trafficPolicy.connectionPool

Type
object
PropertyTypeDescription
httpobject

HTTP connection pool settings.

tcpobject

Settings common to both HTTP and TCP upstream connections.

.spec.subsets[].trafficPolicy.connectionPool.http

Description
HTTP connection pool settings.
Type
object
PropertyTypeDescription
h2UpgradePolicystring

Specify if http1.1 connection should be upgraded to http2 for the associated destination.

http1MaxPendingRequestsinteger
http2MaxRequestsinteger

Maximum number of active requests to a destination.

idleTimeoutstring

The idle timeout for upstream connection pool connections.

maxRequestsPerConnectioninteger

Maximum number of requests per connection to a backend.

maxRetriesinteger
useClientProtocolboolean

If set to true, client protocol will be preserved while initiating connection to backend.

.spec.subsets[].trafficPolicy.connectionPool.tcp

Description
Settings common to both HTTP and TCP upstream connections.
Type
object
PropertyTypeDescription
connectTimeoutstring

TCP connection timeout.

maxConnectionDurationstring

The maximum duration of a connection.

maxConnectionsinteger

Maximum number of HTTP1 /TCP connections to a destination host.

tcpKeepaliveobject

If set then set SO_KEEPALIVE on the socket to enable TCP Keepalives.

.spec.subsets[].trafficPolicy.connectionPool.tcp.tcpKeepalive

Description
If set then set SO_KEEPALIVE on the socket to enable TCP Keepalives.
Type
object
PropertyTypeDescription
intervalstring

The time duration between keep-alive probes.

probesinteger
timestring

.spec.subsets[].trafficPolicy.loadBalancer

Description
Settings controlling the load balancer algorithms.
Type
object
PropertyTypeDescription
consistentHashobject
localityLbSettingobject
simplestring
warmupDurationSecsstring

Represents the warmup duration of Service.

.spec.subsets[].trafficPolicy.loadBalancer.consistentHash

Type
object
PropertyTypeDescription
httpCookieobject

Hash based on HTTP cookie.

httpHeaderNamestring

Hash based on a specific HTTP header.

httpQueryParameterNamestring

Hash based on a specific HTTP query parameter.

maglevobject

The Maglev load balancer implements consistent hashing to backend hosts.

minimumRingSizeinteger

Deprecated.

ringHashobject

The ring/modulo hash load balancer implements consistent hashing to backend hosts.

useSourceIpboolean

Hash based on the source IP address.

.spec.subsets[].trafficPolicy.loadBalancer.consistentHash.httpCookie

Description
Hash based on HTTP cookie.
Type
object
PropertyTypeDescription
namestring

Name of the cookie.

pathstring

Path to set for the cookie.

ttlstring

Lifetime of the cookie.

.spec.subsets[].trafficPolicy.loadBalancer.consistentHash.maglev

Description
The Maglev load balancer implements consistent hashing to backend hosts.
Type
object
PropertyTypeDescription
tableSizeinteger

The table size for Maglev hashing.

.spec.subsets[].trafficPolicy.loadBalancer.consistentHash.ringHash

Description
The ring/modulo hash load balancer implements consistent hashing to backend hosts.
Type
object
PropertyTypeDescription
minimumRingSizeinteger

.spec.subsets[].trafficPolicy.loadBalancer.localityLbSetting

Type
object
PropertyTypeDescription
distributearray

Optional: only one of distribute, failover or failoverPriority can be set.

enabledboolean

enable locality load balancing, this is DestinationRule-level and will override mesh wide settings in entirety.

failoverarray

Optional: only one of distribute, failover or failoverPriority can be set.

failoverPriorityarray

failoverPriority is an ordered list of labels used to sort endpoints to do priority based load balancing.

.spec.subsets[].trafficPolicy.loadBalancer.localityLbSetting.distribute

Description
Optional: only one of distribute, failover or failoverPriority can be set.
Type
array

.spec.subsets[].trafficPolicy.loadBalancer.localityLbSetting.distribute[]

Type
object
PropertyTypeDescription
fromstring

Originating locality, '/' separated, e.g.

toobject

Map of upstream localities to traffic distribution weights.

.spec.subsets[].trafficPolicy.loadBalancer.localityLbSetting.distribute[].to

Description
Map of upstream localities to traffic distribution weights.
Type
object

.spec.subsets[].trafficPolicy.loadBalancer.localityLbSetting.failover

Description
Optional: only one of distribute, failover or failoverPriority can be set.
Type
array

.spec.subsets[].trafficPolicy.loadBalancer.localityLbSetting.failover[]

Type
object
PropertyTypeDescription
fromstring

Originating region.

tostring

.spec.subsets[].trafficPolicy.loadBalancer.localityLbSetting.failoverPriority

Description
failoverPriority is an ordered list of labels used to sort endpoints to do priority based load balancing.
Type
array

.spec.subsets[].trafficPolicy.loadBalancer.localityLbSetting.failoverPriority[]

Type
string

.spec.subsets[].trafficPolicy.outlierDetection

Type
object
PropertyTypeDescription
baseEjectionTimestring

Minimum ejection duration.

consecutive5xxErrorsinteger

Number of 5xx errors before a host is ejected from the connection pool.

consecutiveErrorsinteger
consecutiveGatewayErrorsinteger

Number of gateway errors before a host is ejected from the connection pool.

consecutiveLocalOriginFailuresinteger
intervalstring

Time interval between ejection sweep analysis.

maxEjectionPercentinteger
minHealthPercentinteger
splitExternalLocalOriginErrorsboolean

Determines whether to distinguish local origin failures from external errors.

.spec.subsets[].trafficPolicy.portLevelSettings

Description
Traffic policies specific to individual ports.
Type
array

.spec.subsets[].trafficPolicy.portLevelSettings[]

Type
object
PropertyTypeDescription
connectionPoolobject
loadBalancerobject

Settings controlling the load balancer algorithms.

outlierDetectionobject
portobject
tlsobject

TLS related settings for connections to the upstream service.

.spec.subsets[].trafficPolicy.portLevelSettings[].connectionPool

Type
object
PropertyTypeDescription
httpobject

HTTP connection pool settings.

tcpobject

Settings common to both HTTP and TCP upstream connections.

.spec.subsets[].trafficPolicy.portLevelSettings[].connectionPool.http

Description
HTTP connection pool settings.
Type
object
PropertyTypeDescription
h2UpgradePolicystring

Specify if http1.1 connection should be upgraded to http2 for the associated destination.

http1MaxPendingRequestsinteger
http2MaxRequestsinteger

Maximum number of active requests to a destination.

idleTimeoutstring

The idle timeout for upstream connection pool connections.

maxRequestsPerConnectioninteger

Maximum number of requests per connection to a backend.

maxRetriesinteger
useClientProtocolboolean

If set to true, client protocol will be preserved while initiating connection to backend.

.spec.subsets[].trafficPolicy.portLevelSettings[].connectionPool.tcp

Description
Settings common to both HTTP and TCP upstream connections.
Type
object
PropertyTypeDescription
connectTimeoutstring

TCP connection timeout.

maxConnectionDurationstring

The maximum duration of a connection.

maxConnectionsinteger

Maximum number of HTTP1 /TCP connections to a destination host.

tcpKeepaliveobject

If set then set SO_KEEPALIVE on the socket to enable TCP Keepalives.

.spec.subsets[].trafficPolicy.portLevelSettings[].connectionPool.tcp.tcpKeepalive

Description
If set then set SO_KEEPALIVE on the socket to enable TCP Keepalives.
Type
object
PropertyTypeDescription
intervalstring

The time duration between keep-alive probes.

probesinteger
timestring

.spec.subsets[].trafficPolicy.portLevelSettings[].loadBalancer

Description
Settings controlling the load balancer algorithms.
Type
object
PropertyTypeDescription
consistentHashobject
localityLbSettingobject
simplestring
warmupDurationSecsstring

Represents the warmup duration of Service.

.spec.subsets[].trafficPolicy.portLevelSettings[].loadBalancer.consistentHash

Type
object
PropertyTypeDescription
httpCookieobject

Hash based on HTTP cookie.

httpHeaderNamestring

Hash based on a specific HTTP header.

httpQueryParameterNamestring

Hash based on a specific HTTP query parameter.

maglevobject

The Maglev load balancer implements consistent hashing to backend hosts.

minimumRingSizeinteger

Deprecated.

ringHashobject

The ring/modulo hash load balancer implements consistent hashing to backend hosts.

useSourceIpboolean

Hash based on the source IP address.

.spec.subsets[].trafficPolicy.portLevelSettings[].loadBalancer.consistentHash.httpCookie

Description
Hash based on HTTP cookie.
Type
object
PropertyTypeDescription
namestring

Name of the cookie.

pathstring

Path to set for the cookie.

ttlstring

Lifetime of the cookie.

.spec.subsets[].trafficPolicy.portLevelSettings[].loadBalancer.consistentHash.maglev

Description
The Maglev load balancer implements consistent hashing to backend hosts.
Type
object
PropertyTypeDescription
tableSizeinteger

The table size for Maglev hashing.

.spec.subsets[].trafficPolicy.portLevelSettings[].loadBalancer.consistentHash.ringHash

Description
The ring/modulo hash load balancer implements consistent hashing to backend hosts.
Type
object
PropertyTypeDescription
minimumRingSizeinteger

.spec.subsets[].trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting

Type
object
PropertyTypeDescription
distributearray

Optional: only one of distribute, failover or failoverPriority can be set.

enabledboolean

enable locality load balancing, this is DestinationRule-level and will override mesh wide settings in entirety.

failoverarray

Optional: only one of distribute, failover or failoverPriority can be set.

failoverPriorityarray

failoverPriority is an ordered list of labels used to sort endpoints to do priority based load balancing.

.spec.subsets[].trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting.distribute

Description
Optional: only one of distribute, failover or failoverPriority can be set.
Type
array

.spec.subsets[].trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting.distribute[]

Type
object
PropertyTypeDescription
fromstring

Originating locality, '/' separated, e.g.

toobject

Map of upstream localities to traffic distribution weights.

.spec.subsets[].trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting.distribute[].to

Description
Map of upstream localities to traffic distribution weights.
Type
object

.spec.subsets[].trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting.failover

Description
Optional: only one of distribute, failover or failoverPriority can be set.
Type
array

.spec.subsets[].trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting.failover[]

Type
object
PropertyTypeDescription
fromstring

Originating region.

tostring

.spec.subsets[].trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting.failoverPriority

Description
failoverPriority is an ordered list of labels used to sort endpoints to do priority based load balancing.
Type
array

.spec.subsets[].trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting.failoverPriority[]

Type
string

.spec.subsets[].trafficPolicy.portLevelSettings[].outlierDetection

Type
object
PropertyTypeDescription
baseEjectionTimestring

Minimum ejection duration.

consecutive5xxErrorsinteger

Number of 5xx errors before a host is ejected from the connection pool.

consecutiveErrorsinteger
consecutiveGatewayErrorsinteger

Number of gateway errors before a host is ejected from the connection pool.

consecutiveLocalOriginFailuresinteger
intervalstring

Time interval between ejection sweep analysis.

maxEjectionPercentinteger
minHealthPercentinteger
splitExternalLocalOriginErrorsboolean

Determines whether to distinguish local origin failures from external errors.

.spec.subsets[].trafficPolicy.portLevelSettings[].port

Type
object
PropertyTypeDescription
numberinteger

.spec.subsets[].trafficPolicy.portLevelSettings[].tls

Description
TLS related settings for connections to the upstream service.
Type
object
PropertyTypeDescription
caCertificatesstring
clientCertificatestring

REQUIRED if mode is MUTUAL.

credentialNamestring
insecureSkipVerifyboolean
modestring
privateKeystring

REQUIRED if mode is MUTUAL.

snistring

SNI string to present to the server during TLS handshake.

subjectAltNamesarray

.spec.subsets[].trafficPolicy.portLevelSettings[].tls.subjectAltNames

Type
array

.spec.subsets[].trafficPolicy.portLevelSettings[].tls.subjectAltNames[]

Type
string

.spec.subsets[].trafficPolicy.tls

Description
TLS related settings for connections to the upstream service.
Type
object
PropertyTypeDescription
caCertificatesstring
clientCertificatestring

REQUIRED if mode is MUTUAL.

credentialNamestring
insecureSkipVerifyboolean
modestring
privateKeystring

REQUIRED if mode is MUTUAL.

snistring

SNI string to present to the server during TLS handshake.

subjectAltNamesarray

.spec.subsets[].trafficPolicy.tls.subjectAltNames

Type
array

.spec.subsets[].trafficPolicy.tls.subjectAltNames[]

Type
string

.spec.subsets[].trafficPolicy.tunnel

Type
object
PropertyTypeDescription
protocolstring

Specifies which protocol to use for tunneling the downstream connection.

targetHoststring

Specifies a host to which the downstream connection is tunneled.

targetPortinteger

Specifies a port to which the downstream connection is tunneled.

.spec.trafficPolicy

Type
object
PropertyTypeDescription
connectionPoolobject
loadBalancerobject

Settings controlling the load balancer algorithms.

outlierDetectionobject
portLevelSettingsarray

Traffic policies specific to individual ports.

tlsobject

TLS related settings for connections to the upstream service.

tunnelobject

.spec.trafficPolicy.connectionPool

Type
object
PropertyTypeDescription
httpobject

HTTP connection pool settings.

tcpobject

Settings common to both HTTP and TCP upstream connections.

.spec.trafficPolicy.connectionPool.http

Description
HTTP connection pool settings.
Type
object
PropertyTypeDescription
h2UpgradePolicystring

Specify if http1.1 connection should be upgraded to http2 for the associated destination.

http1MaxPendingRequestsinteger
http2MaxRequestsinteger

Maximum number of active requests to a destination.

idleTimeoutstring

The idle timeout for upstream connection pool connections.

maxRequestsPerConnectioninteger

Maximum number of requests per connection to a backend.

maxRetriesinteger
useClientProtocolboolean

If set to true, client protocol will be preserved while initiating connection to backend.

.spec.trafficPolicy.connectionPool.tcp

Description
Settings common to both HTTP and TCP upstream connections.
Type
object
PropertyTypeDescription
connectTimeoutstring

TCP connection timeout.

maxConnectionDurationstring

The maximum duration of a connection.

maxConnectionsinteger

Maximum number of HTTP1 /TCP connections to a destination host.

tcpKeepaliveobject

If set then set SO_KEEPALIVE on the socket to enable TCP Keepalives.

.spec.trafficPolicy.connectionPool.tcp.tcpKeepalive

Description
If set then set SO_KEEPALIVE on the socket to enable TCP Keepalives.
Type
object
PropertyTypeDescription
intervalstring

The time duration between keep-alive probes.

probesinteger
timestring

.spec.trafficPolicy.loadBalancer

Description
Settings controlling the load balancer algorithms.
Type
object
PropertyTypeDescription
consistentHashobject
localityLbSettingobject
simplestring
warmupDurationSecsstring

Represents the warmup duration of Service.

.spec.trafficPolicy.loadBalancer.consistentHash

Type
object
PropertyTypeDescription
httpCookieobject

Hash based on HTTP cookie.

httpHeaderNamestring

Hash based on a specific HTTP header.

httpQueryParameterNamestring

Hash based on a specific HTTP query parameter.

maglevobject

The Maglev load balancer implements consistent hashing to backend hosts.

minimumRingSizeinteger

Deprecated.

ringHashobject

The ring/modulo hash load balancer implements consistent hashing to backend hosts.

useSourceIpboolean

Hash based on the source IP address.

.spec.trafficPolicy.loadBalancer.consistentHash.httpCookie

Description
Hash based on HTTP cookie.
Type
object
PropertyTypeDescription
namestring

Name of the cookie.

pathstring

Path to set for the cookie.

ttlstring

Lifetime of the cookie.

.spec.trafficPolicy.loadBalancer.consistentHash.maglev

Description
The Maglev load balancer implements consistent hashing to backend hosts.
Type
object
PropertyTypeDescription
tableSizeinteger

The table size for Maglev hashing.

.spec.trafficPolicy.loadBalancer.consistentHash.ringHash

Description
The ring/modulo hash load balancer implements consistent hashing to backend hosts.
Type
object
PropertyTypeDescription
minimumRingSizeinteger

.spec.trafficPolicy.loadBalancer.localityLbSetting

Type
object
PropertyTypeDescription
distributearray

Optional: only one of distribute, failover or failoverPriority can be set.

enabledboolean

enable locality load balancing, this is DestinationRule-level and will override mesh wide settings in entirety.

failoverarray

Optional: only one of distribute, failover or failoverPriority can be set.

failoverPriorityarray

failoverPriority is an ordered list of labels used to sort endpoints to do priority based load balancing.

.spec.trafficPolicy.loadBalancer.localityLbSetting.distribute

Description
Optional: only one of distribute, failover or failoverPriority can be set.
Type
array

.spec.trafficPolicy.loadBalancer.localityLbSetting.distribute[]

Type
object
PropertyTypeDescription
fromstring

Originating locality, '/' separated, e.g.

toobject

Map of upstream localities to traffic distribution weights.

.spec.trafficPolicy.loadBalancer.localityLbSetting.distribute[].to

Description
Map of upstream localities to traffic distribution weights.
Type
object

.spec.trafficPolicy.loadBalancer.localityLbSetting.failover

Description
Optional: only one of distribute, failover or failoverPriority can be set.
Type
array

.spec.trafficPolicy.loadBalancer.localityLbSetting.failover[]

Type
object
PropertyTypeDescription
fromstring

Originating region.

tostring

.spec.trafficPolicy.loadBalancer.localityLbSetting.failoverPriority

Description
failoverPriority is an ordered list of labels used to sort endpoints to do priority based load balancing.
Type
array

.spec.trafficPolicy.loadBalancer.localityLbSetting.failoverPriority[]

Type
string

.spec.trafficPolicy.outlierDetection

Type
object
PropertyTypeDescription
baseEjectionTimestring

Minimum ejection duration.

consecutive5xxErrorsinteger

Number of 5xx errors before a host is ejected from the connection pool.

consecutiveErrorsinteger
consecutiveGatewayErrorsinteger

Number of gateway errors before a host is ejected from the connection pool.

consecutiveLocalOriginFailuresinteger
intervalstring

Time interval between ejection sweep analysis.

maxEjectionPercentinteger
minHealthPercentinteger
splitExternalLocalOriginErrorsboolean

Determines whether to distinguish local origin failures from external errors.

.spec.trafficPolicy.portLevelSettings

Description
Traffic policies specific to individual ports.
Type
array

.spec.trafficPolicy.portLevelSettings[]

Type
object
PropertyTypeDescription
connectionPoolobject
loadBalancerobject

Settings controlling the load balancer algorithms.

outlierDetectionobject
portobject
tlsobject

TLS related settings for connections to the upstream service.

.spec.trafficPolicy.portLevelSettings[].connectionPool

Type
object
PropertyTypeDescription
httpobject

HTTP connection pool settings.

tcpobject

Settings common to both HTTP and TCP upstream connections.

.spec.trafficPolicy.portLevelSettings[].connectionPool.http

Description
HTTP connection pool settings.
Type
object
PropertyTypeDescription
h2UpgradePolicystring

Specify if http1.1 connection should be upgraded to http2 for the associated destination.

http1MaxPendingRequestsinteger
http2MaxRequestsinteger

Maximum number of active requests to a destination.

idleTimeoutstring

The idle timeout for upstream connection pool connections.

maxRequestsPerConnectioninteger

Maximum number of requests per connection to a backend.

maxRetriesinteger
useClientProtocolboolean

If set to true, client protocol will be preserved while initiating connection to backend.

.spec.trafficPolicy.portLevelSettings[].connectionPool.tcp

Description
Settings common to both HTTP and TCP upstream connections.
Type
object
PropertyTypeDescription
connectTimeoutstring

TCP connection timeout.

maxConnectionDurationstring

The maximum duration of a connection.

maxConnectionsinteger

Maximum number of HTTP1 /TCP connections to a destination host.

tcpKeepaliveobject

If set then set SO_KEEPALIVE on the socket to enable TCP Keepalives.

.spec.trafficPolicy.portLevelSettings[].connectionPool.tcp.tcpKeepalive

Description
If set then set SO_KEEPALIVE on the socket to enable TCP Keepalives.
Type
object
PropertyTypeDescription
intervalstring

The time duration between keep-alive probes.

probesinteger
timestring

.spec.trafficPolicy.portLevelSettings[].loadBalancer

Description
Settings controlling the load balancer algorithms.
Type
object
PropertyTypeDescription
consistentHashobject
localityLbSettingobject
simplestring
warmupDurationSecsstring

Represents the warmup duration of Service.

.spec.trafficPolicy.portLevelSettings[].loadBalancer.consistentHash

Type
object
PropertyTypeDescription
httpCookieobject

Hash based on HTTP cookie.

httpHeaderNamestring

Hash based on a specific HTTP header.

httpQueryParameterNamestring

Hash based on a specific HTTP query parameter.

maglevobject

The Maglev load balancer implements consistent hashing to backend hosts.

minimumRingSizeinteger

Deprecated.

ringHashobject

The ring/modulo hash load balancer implements consistent hashing to backend hosts.

useSourceIpboolean

Hash based on the source IP address.

.spec.trafficPolicy.portLevelSettings[].loadBalancer.consistentHash.httpCookie

Description
Hash based on HTTP cookie.
Type
object
PropertyTypeDescription
namestring

Name of the cookie.

pathstring

Path to set for the cookie.

ttlstring

Lifetime of the cookie.

.spec.trafficPolicy.portLevelSettings[].loadBalancer.consistentHash.maglev

Description
The Maglev load balancer implements consistent hashing to backend hosts.
Type
object
PropertyTypeDescription
tableSizeinteger

The table size for Maglev hashing.

.spec.trafficPolicy.portLevelSettings[].loadBalancer.consistentHash.ringHash

Description
The ring/modulo hash load balancer implements consistent hashing to backend hosts.
Type
object
PropertyTypeDescription
minimumRingSizeinteger

.spec.trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting

Type
object
PropertyTypeDescription
distributearray

Optional: only one of distribute, failover or failoverPriority can be set.

enabledboolean

enable locality load balancing, this is DestinationRule-level and will override mesh wide settings in entirety.

failoverarray

Optional: only one of distribute, failover or failoverPriority can be set.

failoverPriorityarray

failoverPriority is an ordered list of labels used to sort endpoints to do priority based load balancing.

.spec.trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting.distribute

Description
Optional: only one of distribute, failover or failoverPriority can be set.
Type
array

.spec.trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting.distribute[]

Type
object
PropertyTypeDescription
fromstring

Originating locality, '/' separated, e.g.

toobject

Map of upstream localities to traffic distribution weights.

.spec.trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting.distribute[].to

Description
Map of upstream localities to traffic distribution weights.
Type
object

.spec.trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting.failover

Description
Optional: only one of distribute, failover or failoverPriority can be set.
Type
array

.spec.trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting.failover[]

Type
object
PropertyTypeDescription
fromstring

Originating region.

tostring

.spec.trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting.failoverPriority

Description
failoverPriority is an ordered list of labels used to sort endpoints to do priority based load balancing.
Type
array

.spec.trafficPolicy.portLevelSettings[].loadBalancer.localityLbSetting.failoverPriority[]

Type
string

.spec.trafficPolicy.portLevelSettings[].outlierDetection

Type
object
PropertyTypeDescription
baseEjectionTimestring

Minimum ejection duration.

consecutive5xxErrorsinteger

Number of 5xx errors before a host is ejected from the connection pool.

consecutiveErrorsinteger
consecutiveGatewayErrorsinteger

Number of gateway errors before a host is ejected from the connection pool.

consecutiveLocalOriginFailuresinteger
intervalstring

Time interval between ejection sweep analysis.

maxEjectionPercentinteger
minHealthPercentinteger
splitExternalLocalOriginErrorsboolean

Determines whether to distinguish local origin failures from external errors.

.spec.trafficPolicy.portLevelSettings[].port

Type
object
PropertyTypeDescription
numberinteger

.spec.trafficPolicy.portLevelSettings[].tls

Description
TLS related settings for connections to the upstream service.
Type
object
PropertyTypeDescription
caCertificatesstring
clientCertificatestring

REQUIRED if mode is MUTUAL.

credentialNamestring
insecureSkipVerifyboolean
modestring
privateKeystring

REQUIRED if mode is MUTUAL.

snistring

SNI string to present to the server during TLS handshake.

subjectAltNamesarray

.spec.trafficPolicy.portLevelSettings[].tls.subjectAltNames

Type
array

.spec.trafficPolicy.portLevelSettings[].tls.subjectAltNames[]

Type
string

.spec.trafficPolicy.tls

Description
TLS related settings for connections to the upstream service.
Type
object
PropertyTypeDescription
caCertificatesstring
clientCertificatestring

REQUIRED if mode is MUTUAL.

credentialNamestring
insecureSkipVerifyboolean
modestring
privateKeystring

REQUIRED if mode is MUTUAL.

snistring

SNI string to present to the server during TLS handshake.

subjectAltNamesarray

.spec.trafficPolicy.tls.subjectAltNames

Type
array

.spec.trafficPolicy.tls.subjectAltNames[]

Type
string

.spec.trafficPolicy.tunnel

Type
object
PropertyTypeDescription
protocolstring

Specifies which protocol to use for tunneling the downstream connection.

targetHoststring

Specifies a host to which the downstream connection is tunneled.

targetPortinteger

Specifies a port to which the downstream connection is tunneled.

.spec.workloadSelector

Type
object
PropertyTypeDescription
matchLabelsobject

.spec.workloadSelector.matchLabels

Type
object

.status

Type
object

API Endpoints

The following API endpoints are available:

  • /apis/networking.istio.io/v1alpha3/namespaces/{namespace}/destinationrules
    • DELETE: delete collection of DestinationRule
    • GET: list objects of kind DestinationRule
    • POST: create a new DestinationRule
  • /apis/networking.istio.io/v1alpha3/namespaces/{namespace}/destinationrules/{name}
    • DELETE: delete the specified DestinationRule
    • GET: read the specified DestinationRule
    • PATCH: partially update the specified DestinationRule
    • PUT: replace the specified DestinationRule
  • /apis/networking.istio.io/v1alpha3/namespaces/{namespace}/destinationrules/{name}/status
    • GET: read status of the specified DestinationRule
    • PATCH: partially update status of the specified DestinationRule
    • PUT: replace status of the specified DestinationRule

/apis/networking.istio.io/v1alpha3/namespaces/{namespace}/destinationrules

HTTP method
DELETE
Description
delete collection of DestinationRule
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
list objects of kind DestinationRule
HTTP responses
HTTP codeResponse body
200 - OKDestinationRuleList schema
401 - UnauthorizedEmpty
HTTP method
POST
Description
create a new DestinationRule
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyDestinationRule schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKDestinationRule schema
201 - CreatedDestinationRule schema
202 - AcceptedDestinationRule schema
401 - UnauthorizedEmpty

/apis/networking.istio.io/v1alpha3/namespaces/{namespace}/destinationrules/{name}

HTTP method
DELETE
Description
delete the specified DestinationRule
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
HTTP responses
HTTP codeResponse body
200 - OKStatus schema
202 - AcceptedStatus schema
401 - UnauthorizedEmpty
HTTP method
GET
Description
read the specified DestinationRule
HTTP responses
HTTP codeResponse body
200 - OKDestinationRule schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update the specified DestinationRule
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKDestinationRule schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace the specified DestinationRule
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyDestinationRule schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKDestinationRule schema
201 - CreatedDestinationRule schema
401 - UnauthorizedEmpty

/apis/networking.istio.io/v1alpha3/namespaces/{namespace}/destinationrules/{name}/status

HTTP method
GET
Description
read status of the specified DestinationRule
HTTP responses
HTTP codeResponse body
200 - OKDestinationRule schema
401 - UnauthorizedEmpty
HTTP method
PATCH
Description
partially update status of the specified DestinationRule
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
HTTP responses
HTTP codeResponse body
200 - OKDestinationRule schema
401 - UnauthorizedEmpty
HTTP method
PUT
Description
replace status of the specified DestinationRule
Query parameters
ParameterTypeDescription
dryRunstringWhen present, indicates that modifications should not be persisted. An invalid or unrecognized dryRun directive will result in an error response and no further processing of the request. Valid values are: - All: all dry run stages will be processed
fieldValidationstringfieldValidation instructs the server on how to handle objects in the request (POST/PUT/PATCH) containing unknown or duplicate fields. Valid values are: - Ignore: This will ignore any unknown fields that are silently dropped from the object, and will ignore all but the last duplicate field that the decoder encounters. This is the default behavior prior to v1.23. - Warn: This will send a warning via the standard warning response header for each unknown field that is dropped from the object, and for each duplicate field that is encountered. The request will still succeed if there are no other errors, and will only persist the last of any duplicate fields. This is the default in v1.23+ - Strict: This will fail the request with a BadRequest error if any unknown fields would be dropped from the object, or if any duplicate fields are present. The error returned from the server will contain all unknown and duplicate fields encountered.
Body parameters
ParameterTypeDescription
bodyDestinationRule schemaapplication/json formatted
HTTP responses
HTTP codeResponse body
200 - OKDestinationRule schema
201 - CreatedDestinationRule schema
401 - UnauthorizedEmpty